"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _a;
exports.__esModule = true;
var electron_1 = require("electron");
var isDev = require("electron-is-dev");
var fs_1 = require("fs");
var path = require("path");
var usbDetect = require("usb-detection");
var util_1 = require("util");
var userNotification_1 = require("./userNotification");
// Using sudoPromptExec to clarify it's for elevated permissions
var sudoPromptExec = require('sudo-prompt').exec;
var exec = util_1.promisify(require('child_process').exec);
var executeCommand = function (command) {
    return new Promise(function (resolve, reject) {
        exec(command, function (error, stdout, stderr) {
            if (error) {
                reject({ error: error.message, stderr: stderr });
            }
            else if (stderr) {
                reject({ error: 'Error output received', stderr: stderr });
            }
            else {
                resolve(stdout);
            }
        });
    });
};
var SUPPORTED_DEVICES_STRING = [
    { vendorId: '20A0', productIds: ['42DB', '42DA'] },
    { vendorId: '3603', productIds: ['0001', '0002', '0003', '0004'] }
];
var SUPPORTED_DEVICES = [
    { vendorId: 0x20a0, productIds: [0x42db, 0x42da] },
    { vendorId: 0x3603, productIds: [0x0001, 0x0002, 0x0003, 0x0004] }
];
// Handle creating/removing shortcuts on Windows when installing/uninstalling.
if (require('electron-squirrel-startup')) {
    electron_1.app.quit();
}
var REACT_DEV_URL = 'http://localhost:3000';
// Global reference to mainWindow (necessary to prevent window from being garbage collected)
var mainWindow;
var isElectron = 'electron' in process.versions;
var isUsingAsar = isElectron && ((_a = process.mainModule) === null || _a === void 0 ? void 0 : _a.filename.includes('app.asar'));
var fixPathForAsarUnpack = function (path) {
    return isUsingAsar ? path.replace('app.asar', 'app.asar.unpacked') : path;
};
var createRulesForLinux = function () { return __awaiter(void 0, void 0, void 0, function () {
    var deviceArguments, checkCommand, checkResult, results, changesRequired, response, updateCommand, updateResult, error_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                deviceArguments = SUPPORTED_DEVICES_STRING.reduce(function (acc, device) {
                    var ids = device.productIds.map(function (pid) { return encodeURIComponent(device.vendorId) + " " + encodeURIComponent(pid); });
                    return acc.concat(ids);
                }, []).join(' ');
                checkCommand = "bash " + path.join(fixPathForAsarUnpack(__dirname), '../src/readRules.sh') + " " + deviceArguments;
                _a.label = 1;
            case 1:
                _a.trys.push([1, 10, , 11]);
                return [4 /*yield*/, exec(checkCommand)];
            case 2:
                checkResult = _a.sent();
                console.log('Full output from check script:', checkResult.stdout);
                results = checkResult.stdout
                    .trim()
                    .split('\n')
                    .map(function (line) { return line.trim(); });
                changesRequired = results.includes('Changes required');
                if (!changesRequired) return [3 /*break*/, 8];
                console.log('readRules is reporting that changes are required');
                // First notify the user with a popup that changes are required
                userNotification_1.notifyUserPopup('Update Required', 'Changes to udev rules are required for your MuteMe device to function properly on Linux.', 8000, true, 'Learn More', 'https://muteme.com/pages/linuxsetup');
                return [4 /*yield*/, delay(7000)
                    // Then ask if they want to perform the update
                ]; // Wait for the user to acknowledge the popup
            case 3:
                _a.sent(); // Wait for the user to acknowledge the popup
                return [4 /*yield*/, electron_1.dialog.showMessageBox({
                        type: 'info',
                        buttons: ['Update', 'Cancel'],
                        defaultId: 0,
                        title: 'Permission Required',
                        message: 'Would you like to update the udev rules now? This operation requires elevated permissions.',
                        detail: 'Updating will ensure your device functions correctly.'
                    })];
            case 4:
                response = (_a.sent()).response;
                if (!(response === 0)) return [3 /*break*/, 6];
                updateCommand = "bash " + path.join(fixPathForAsarUnpack(__dirname), '../src/updateRules.sh') + " " + deviceArguments;
                console.log('Executing the update command with elevated permissions');
                return [4 /*yield*/, sudoPromptExec(updateCommand, { name: 'MuteMe' })];
            case 5:
                updateResult = _a.sent();
                console.log('Update script executed successfully:', updateResult);
                return [3 /*break*/, 7];
            case 6:
                console.log('User canceled the udev rule update.');
                userNotification_1.notifyUserPopup('Update Required To Use MuteMe', 'Changes to udev rules are required for your MuteMe device to connect, you can choose to do this manually', 12000, true, 'Learn More', 'https://muteme.com/pages/linuxsetup');
                _a.label = 7;
            case 7: return [3 /*break*/, 9];
            case 8:
                console.log('No changes to udev rules required.');
                _a.label = 9;
            case 9:
                checkPulseAudio(); // Check PulseAudio status
                return [2 /*return*/, true];
            case 10:
                error_1 = _a.sent();
                console.error('Failed to execute script:', error_1);
                return [2 /*return*/, false];
            case 11: return [2 /*return*/];
        }
    });
}); };
var createMainWindow = function () {
    var mainWindow = new electron_1.BrowserWindow({
        width: 600,
        height: 750,
        resizable: false,
        frame: true,
        backgroundColor: '#282c34',
        titleBarStyle: 'hidden',
        webPreferences: {
            nodeIntegration: true,
            enableRemoteModule: true,
            preload: path.join(__dirname, 'preload.js'),
            backgroundThrottling: false
        }
    });
    var startURL = isDev
        ? REACT_DEV_URL
        : "file://" + path.join(__dirname, '../static/build/index.html');
    mainWindow.loadURL(startURL);
    mainWindow.setMenuBarVisibility(false);
    usbDetect.startMonitoring();
    // Initialize an object to keep track of connected devices
    var connectedDevices = {};
    SUPPORTED_DEVICES.forEach(function (device) {
        device.productIds.forEach(function (pid) {
            var eventString = "add:" + device.vendorId + ":" + pid;
            var removeString = "remove:" + device.vendorId + ":" + pid;
            usbDetect.on(eventString, function (device) {
                var deviceKey = device.vendorId + ":" + pid;
                if (!connectedDevices[deviceKey]) {
                    console.log("[Electron]: plugged in MuteMe", device);
                    mainWindow === null || mainWindow === void 0 ? void 0 : mainWindow.webContents.send('usb-detected-muteme', device);
                    connectedDevices[deviceKey] = true;
                }
            });
            usbDetect.on(removeString, function (device) {
                var deviceKey = device.vendorId + ":" + pid;
                if (connectedDevices[deviceKey]) {
                    console.log("[Electron]: unplugged MuteMe", device);
                    mainWindow === null || mainWindow === void 0 ? void 0 : mainWindow.webContents.send('usb-detected-unmuteme', device); // Notify frontend about the disconnection
                    delete connectedDevices[deviceKey];
                }
            });
        });
    });
    if (process.platform === 'linux') {
        createRulesForLinux().then(function (rulesExist) { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                console.log("rules exist for linux: " + rulesExist);
                if (rulesExist) {
                    SUPPORTED_DEVICES.forEach(function (device) { return __awaiter(void 0, void 0, void 0, function () {
                        var devices;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, usbDetect.find(device.vendorId)];
                                case 1:
                                    devices = _a.sent();
                                    devices
                                        .filter(function (d) { return device.productIds.includes(d.productId); })
                                        .forEach(function (d) {
                                        mainWindow === null || mainWindow === void 0 ? void 0 : mainWindow.webContents.send('usb-detected-muteme', d);
                                    });
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                }
                return [2 /*return*/];
            });
        }); });
    }
    mainWindow.on('closed', function () {
        usbDetect.stopMonitoring();
        connectedDevices = {};
        mainWindow = undefined;
    });
};
var exitApp = function () {
    try {
        usbDetect.stopMonitoring();
    }
    catch (error) {
        console.log(error);
    }
    electron_1.app.quit();
};
electron_1.app.commandLine.appendSwitch('disable-renderer-backgrounding');
// Quit application when all windows are closed
electron_1.app.on('window-all-closed', function () {
    // On macOS it is common for applications to stay open until the user explicitly quits
    // if (process.platform !== 'darwin') {
    exitApp();
    // }
});
electron_1.app.on('activate', function () {
    // On macOS it is common to re-create a window even after all windows have been closed
    if (!mainWindow) {
        createMainWindow();
    }
});
var gotTheLock = electron_1.app.requestSingleInstanceLock();
if (!gotTheLock) {
    exitApp();
}
else {
    electron_1.app.on('second-instance', function (_event, _commandLine, _workingDirectory) {
        // Someone tried to run a second instance, we should focus our window.
        if (mainWindow) {
            if (mainWindow.isMinimized())
                mainWindow.restore();
            mainWindow.focus();
        }
    });
    // Create mainWindow, load the rest of the app, etc...
    electron_1.app.whenReady().then(function () {
        createMainWindow();
    });
}
electron_1.ipcMain.handle('log', function (_event) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    console.debug.apply(console, args);
});
function delay(ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
}
var checkPulseAudio = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, delay(5000)]; // Delay for reassurance
            case 1:
                _a.sent(); // Delay for reassurance
                exec('pulseaudio --check', function (error, stdout, stderr) { return __awaiter(void 0, void 0, void 0, function () {
                    var startError_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!error) return [3 /*break*/, 7];
                                if (!(error.code === 1)) return [3 /*break*/, 5];
                                console.log('PulseAudio is not running, attempting to start...');
                                _a.label = 1;
                            case 1:
                                _a.trys.push([1, 3, , 4]);
                                return [4 /*yield*/, exec('pulseaudio --start')];
                            case 2:
                                _a.sent();
                                console.log('PulseAudio started successfully.');
                                return [3 /*break*/, 4];
                            case 3:
                                startError_1 = _a.sent();
                                console.error('Failed to start PulseAudio:', startError_1);
                                userNotification_1.notifyUserPopup('PulseAudio Start Failed', 'Failed to start PulseAudio. Please manually start it for full functionality.', 10000, true, 'Learn More', 'https://muteme.com/pages/linuxsetup');
                                return [3 /*break*/, 4];
                            case 4: return [3 /*break*/, 6];
                            case 5:
                                // Other errors (e.g., command not found)
                                console.error('Failed to execute PulseAudio check:', error);
                                notifyUserAboutPulseAudio();
                                _a.label = 6;
                            case 6: return [3 /*break*/, 8];
                            case 7:
                                console.log('PulseAudio is running');
                                _a.label = 8;
                            case 8: return [2 /*return*/];
                        }
                    });
                }); });
                return [2 /*return*/];
        }
    });
}); };
var notifyUserAboutPulseAudio = function () { return __awaiter(void 0, void 0, void 0, function () {
    var response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                userNotification_1.notifyUserPopup('Pulseaudio Required', 'Pulseaudio is required to control the microphone, without it you cannot mute or unmute the microphone', 7000, true, 'Learn More', 'https://muteme.com/pages/linuxsetup');
                return [4 /*yield*/, delay(7000)]; // Wait for the user to acknowledge the popup
            case 1:
                _a.sent(); // Wait for the user to acknowledge the popup
                return [4 /*yield*/, electron_1.dialog.showMessageBox({
                        type: 'info',
                        buttons: ['Install', 'Cancel'],
                        defaultId: 0,
                        title: 'PulseAudio Missing',
                        message: 'PulseAudio is not installed or not running. Would you like us to install and enable it?',
                        detail: 'Installing PulseAudio will allow for microphone controll',
                        noLink: true
                    })];
            case 2:
                response = (_a.sent()).response;
                if (response === 0) {
                    console.log('User opted to install PulseAudio.');
                    installAndActivatePulseAudio();
                }
                else {
                    console.log('User cancelled the PulseAudio installation.');
                    userNotification_1.notifyUserPopup('Pulse Audio Required', 'Pulse Audio is required to control microphone you can enable it manually', 10000, true, 'Learn More', 'https://muteme.com/pages/linuxsetup');
                }
                return [2 /*return*/];
        }
    });
}); };
var scriptPath = path.join(fixPathForAsarUnpack(__dirname), '../src/installPulseAudio.sh');
// Function to ensure the script is executable
var ensureScriptExecutable = function (scriptPath) { return __awaiter(void 0, void 0, void 0, function () {
    var chmodCommand, result, error_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 3, , 4]);
                // Check if the script can be accessed
                return [4 /*yield*/, fs_1.promises.access(scriptPath, fs_1.constants.F_OK)];
            case 1:
                // Check if the script can be accessed
                _a.sent();
                console.log('Script found, setting executable permissions...');
                chmodCommand = "chmod 0755 " + scriptPath;
                return [4 /*yield*/, sudoPromptExecPromise(chmodCommand, { name: 'MuteMe' })];
            case 2:
                result = _a.sent();
                console.log('Script is now executable:', result.stdout);
                return [3 /*break*/, 4];
            case 3:
                error_2 = _a.sent();
                console.error('Error setting script permissions:', error_2);
                throw new Error('Failed to set script permissions.');
            case 4: return [2 /*return*/];
        }
    });
}); };
// Wrapping sudoPromptExec to return a Promise with explicit types
var sudoPromptExecPromise = function (command, options) {
    return new Promise(function (resolve, reject) {
        sudoPromptExec(command, options, function (error, stdout, stderr) {
            if (error) {
                reject({ error: error, stderr: stderr }); // Reject the Promise with error and stderr
            }
            else {
                resolve({ stdout: stdout, stderr: stderr }); // Resolve the Promise with stdout and stderr
            }
        });
    });
};
var installAndActivatePulseAudio = function () { return __awaiter(void 0, void 0, void 0, function () {
    var scriptExecutionCommand, scriptResult, error_3;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 6, , 7]);
                console.log('Initiating PulseAudio installation process...');
                // Ensure the script is executable
                return [4 /*yield*/, ensureScriptExecutable(scriptPath)
                    // Proceed with the script execution
                ];
            case 1:
                // Ensure the script is executable
                _a.sent();
                scriptExecutionCommand = "bash " + scriptPath;
                console.log("Executing script: " + scriptExecutionCommand);
                return [4 /*yield*/, sudoPromptExecPromise(scriptExecutionCommand, { name: 'MuteMe' })];
            case 2:
                scriptResult = _a.sent();
                console.log('Sudo Script execution result:', scriptResult.stdout);
                return [4 /*yield*/, executeCommand("pulseaudio --start")];
            case 3:
                _a.sent();
                console.log('PulseAudio installation and configuration commands completed.');
                return [4 /*yield*/, delay(5000)]; // Delay for reassurance
            case 4:
                _a.sent(); // Delay for reassurance
                return [4 /*yield*/, checkPulseAudioPostInstallation()];
            case 5:
                _a.sent();
                return [3 /*break*/, 7];
            case 6:
                error_3 = _a.sent();
                console.error('An error occurred during the PulseAudio installation process:', error_3);
                userNotification_1.notifyUserPopup('Pulseaudio Installation Failed', 'Failed to install or activate PulseAudio. Please try manually or contact support.', 7000, true, 'Learn More', 'https://muteme.com/pages/linuxsetup');
                return [3 /*break*/, 7];
            case 7: return [2 /*return*/];
        }
    });
}); };
var checkPulseAudioPostInstallation = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        exec('pulseaudio --check', function (error, stdout, stderr) {
            if (error) {
                console.error('Checking PulseAudio status failed:', error);
                console.log('Standard Output:', stdout); // Log stdout for more context
                console.error('Standard Error:', stderr); // Log stderr for potential errors
                var message = error.code === 1
                    ? 'PulseAudio was installed but could not be started. Please manually start PulseAudio.'
                    : 'Unable to verify if PulseAudio is running. Please check manually.';
                userNotification_1.notifyUserPopup('Pulseaudio Post-Installation Check Failed', "" + message, 7000, true, 'Learn More', 'https://muteme.com/pages/linuxsetup');
            }
            else {
                console.log('PulseAudio is active and running after installation.');
                userNotification_1.notifyUserPopup('Pulseaudio Installed', 'PulseAudio has been successfully installed and activated.', 7500, true, 'Learn More', 'https://muteme.com/pages/linuxsetup');
            }
        });
        return [2 /*return*/];
    });
}); };
//# sourceMappingURL=index.js.map