var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
var _a = require('electron'), ipcRenderer = _a.ipcRenderer, app = _a.app, remote = _a.remote;
function byOS(handlers, fallback) {
    var handler = handlers[process.platform];
    console.log(handler);
    if (!handler) {
        if (typeof fallback === 'function')
            return fallback();
        return fallback;
    }
    if (typeof handler === 'function')
        return handler();
    return handler;
}
function getOS() {
    return process.platform;
}
window.byOS = byOS;
window.getOS = getOS;
var winAudio = null;
var macAudio = null;
var linuxAudio = null;
if (getOS() === 'win32') {
    try {
        winAudio = require('win-audio').mic;
    }
    catch (error) {
        winAudio = null;
    }
}
if (getOS() === 'darwin') {
    try {
        macAudio = require('@muteme/mac-audio');
    }
    catch (error) {
        macAudio = null;
    }
}
if (getOS() === 'linux') {
    try {
        linuxAudio = require('@muteme/linux-audio');
    }
    catch (error) {
        linuxAudio = null;
    }
}
var macIsMuted = function () { return __awaiter(_this, void 0, void 0, function () {
    var deviceId, isMuted;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, macAudio.getDefaultInputDevice()];
            case 1:
                deviceId = (_a.sent()).id;
                return [4 /*yield*/, macAudio.getDeviceMute(deviceId)];
            case 2:
                isMuted = _a.sent();
                return [2 /*return*/, isMuted];
        }
    });
}); };
var macMute = function () { return __awaiter(_this, void 0, void 0, function () {
    var deviceId, isMuted;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, macAudio.getDefaultInputDevice()];
            case 1:
                deviceId = (_a.sent()).id;
                return [4 /*yield*/, macAudio.getDeviceMute(deviceId)];
            case 2:
                isMuted = _a.sent();
                if (!!isMuted) return [3 /*break*/, 4];
                return [4 /*yield*/, macAudio.toggleDeviceMute(deviceId)];
            case 3:
                _a.sent();
                return [2 /*return*/, true];
            case 4: return [2 /*return*/, false];
        }
    });
}); };
var macUnmute = function () { return __awaiter(_this, void 0, void 0, function () {
    var deviceId, isMuted;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, macAudio.getDefaultInputDevice()];
            case 1:
                deviceId = (_a.sent()).id;
                return [4 /*yield*/, macAudio.getDeviceMute(deviceId)];
            case 2:
                isMuted = _a.sent();
                if (!isMuted) return [3 /*break*/, 4];
                return [4 /*yield*/, macAudio.toggleDeviceMute(deviceId)];
            case 3:
                _a.sent();
                return [2 /*return*/, true];
            case 4: return [2 /*return*/, false];
        }
    });
}); };
var microphone = {
    isMuted: winAudio
        ? winAudio.isMuted
        : macAudio
            ? macIsMuted
            : linuxAudio
                ? linuxAudio.isMuted
                : function () { return null; },
    mute: winAudio ? winAudio.mute : macAudio ? macMute : linuxAudio ? linuxAudio.mute : function () { return null; },
    unmute: winAudio
        ? winAudio.unmute
        : macAudio
            ? macUnmute
            : linuxAudio
                ? linuxAudio.unmute
                : function () { return null; }
};
var zoomControl = require('@muteme/zoom-control');
var customTitlebar = require('custom-electron-titlebar');
var HID = require('node-hid');
var Menu = remote.Menu;
window.ipcRenderer = ipcRenderer;
window.app = app;
window.microphone = microphone;
window.HID = HID;
window.zoomControl = zoomControl;
window.clientVersion = remote.app.getVersion();
// if (['win32'].includes(process.platform)) {
//   window.addEventListener('DOMContentLoaded', () => {
//     const menu = new Menu()
//     const MyTitleBar = new customTitlebar.Titlebar({
//       backgroundColor: customTitlebar.Color.fromHex('#282c34'),
//       menu,
//       titleHorizontalAlignment: 'left'
//     })
//     MyTitleBar.updateTitle('MuteMe Client')
//   })
// }
//# sourceMappingURL=preload.js.map