export const mute: {
  /**
  Mutes all audio inputs.

  @returns void

  @example
  ```
  await mute();
  ```
  */
  (): void

  /**
  Mutes all audio inputs. Synchronous.

  @returns void.

  @example
  ```
  mute.sync();
  ```
  */
  sync: () => void
}

export const unmute: {
  /**
  Unmutes all audio inputs.

  @returns void

  @example
  ```
  await unmute();
  ```
  */
  (): void

  /**
  Unmutes all audio inputs. Synchronous.

  @returns void.

  @example
  ```
  unmute.sync();
  ```
  */
  sync: () => void
}

export const toggleMute: {
  /**
  Toggles the mute status for all audio inputs.

  @returns void

  @example
  ```
  await toggleMute();
  ```
  */
  (): void

  /**
  Toggles the mute status for all audio inputs. Synchronous.

  @returns void.

  @example
  ```
  toggleMute.sync();
  ```
  */
  sync: () => void
}

export const isMuted: {
  /**
  Tells you if any input device is muted.

  @returns boolean

  @example
  ```
  const isDeviceMuted = await isMuted();
  ```
  */
  (): boolean

  /**
  Tells you if any input device is muted. Synchronous.

  @returns boolean.

  @example
  ```
  const isDeviceMuted = mute.isMuted();
  ```
  */
  sync: () => boolean
}