#include "SimpleAsyncWorker.h"

Value getZoomStatus(const CallbackInfo& info) {
    Function callback = info[0].As<Function>();
    SimpleAsyncWorker* asyncWorker = new SimpleAsyncWorker(callback, "getZoomStatus");
    asyncWorker->Queue();
    std::string msg = "Queued a SimpleAsyncWorker";
    return String::New(info.Env(),msg.c_str());
};

Value toggleZoomMute(const CallbackInfo& info) {
    Function callback = info[0].As<Function>();
    SimpleAsyncWorker* asyncWorker = new SimpleAsyncWorker(callback, "toggleZoomMute");
    asyncWorker->Queue();
    std::string msg = "Queued a SimpleAsyncWorker";
    return String::New(info.Env(),msg.c_str());
};

Object Init(Env env, Object exports) {
    exports["getZoomStatus"] = Function::New(env, getZoomStatus, std::string("getZoomStatus"));
    exports["toggleZoomMute"] = Function::New(env, toggleZoomMute, std::string("toggleZoomMute"));
    return exports;
}

NODE_API_MODULE(addon, Init)