#include "SimpleAsyncWorker.h"
#include "ZoomControls.h"
#include <chrono>
#include <thread>

SimpleAsyncWorker::SimpleAsyncWorker(Function &callback, std::string zoomAction)
    : AsyncWorker(callback), zoomStatus("not started"), zoomAction(zoomAction) {};

void SimpleAsyncWorker::Execute()
{

    if (zoomAction == "toggleZoomMute")
    {
        zoomStatus = ZoomControls::osToggleZoomMute();
    }
    else
    {
        zoomStatus = ZoomControls::osGetZoomStatus();
    }
};

void SimpleAsyncWorker::OnOK()
{
    // std::string msg = "SimpleAsyncWorker returning after 'working' " + zoomStatus + " seconds.";
    Callback().Call({Env().Null(), String::New(Env(), zoomStatus)});
};