#!/bin/sh

cd /etc/udev/rules.d/
EXPECTED_RULES_CONTENT=""

echo 'Received arguments: ' "$@"  # Debugging output

# Build expected rules content from provided arguments
while [ $# -gt 0 ]; do
    VENDOR_ID=$1
    shift
    PRODUCT_ID=$1
    shift
    EXPECTED_RULES_CONTENT="$EXPECTED_RULES_CONTENT
SUBSYSTEM==\"usb\", ATTRS{idVendor}==\"$VENDOR_ID\", ATTRS{idProduct}==\"$PRODUCT_ID\", MODE=\"0666\", GROUP=\"plugdev\"
KERNEL==\"hidraw*\", ATTRS{idVendor}==\"$VENDOR_ID\", ATTRS{idProduct}==\"$PRODUCT_ID\", MODE=\"0666\", GROUP=\"plugdev\""
done

# Read the current rules file content
CURRENT_RULES_CONTENT=$(cat muteme.rules)

# Compare expected content with current content
if [ "$EXPECTED_RULES_CONTENT" != "$CURRENT_RULES_CONTENT" ]; then
    echo "$EXPECTED_RULES_CONTENT" > muteme.rules
    echo "udev rules were updated."

    # Reload udev rules and trigger
    udevadm control --reload-rules
    udevadm trigger
else
    echo "No changes to udev rules required."
fi

echo 'success'
