#!/bin/bash

# Function to check if a command exists
command_exists() {
    command -v "$1" >/dev/null 2>&1
}

# Detect if the system is Debian/Ubuntu-based
if command_exists apt; then
    echo "Detected Debian/Ubuntu-based system."
    sudo apt update
    sudo apt install pulseaudio -y
    echo "PulseAudio installed on Debian/Ubuntu-based system."

# Detect if the system is Fedora/Red Hat/openSUSE-based
elif command_exists dnf; then
    echo "Detected Fedora/Red Hat/openSUSE-based system."
    sudo dnf install pulseaudio pulseaudio-utils -y
    echo "PulseAudio and PulseAudio-utils installed on Fedora/Red Hat/openSUSE-based system."

else
    echo "Unsupported Linux distribution."
    exit 1
fi
