#!/bin/sh
#We need to add MuteMe to linux udev rules file
# Define the path to the udev rules file
RULES_PATH="/etc/udev/rules.d"
RULES_FILE="${RULES_PATH}/muteme.rules"

echo "Operating on udev rules file at: $RULES_FILE"

cd $RULES_PATH
EXPECTED_RULES_CONTENT=""
echo 'Received arguments: ' "$@"  # Debugging output

# Build expected rules content from provided arguments
while [ $# -gt 0 ]; do
    VENDOR_ID=$1
    shift
    PRODUCT_ID=$1
    shift
    EXPECTED_RULES_CONTENT="$EXPECTED_RULES_CONTENT
SUBSYSTEM==\"usb\", ATTRS{idVendor}==\"$VENDOR_ID\", ATTRS{idProduct}==\"$PRODUCT_ID\", MODE=\"0666\", GROUP=\"plugdev\"
KERNEL==\"hidraw*\", ATTRS{idVendor}==\"$VENDOR_ID\", ATTRS{idProduct}==\"$PRODUCT_ID\", MODE=\"0666\", GROUP=\"plugdev\""
done

# Safely read the current rules file content
CURRENT_RULES_CONTENT=$(cat "$RULES_FILE" 2>/dev/null)

# Compare expected content with current content
if [ "$EXPECTED_RULES_CONTENT" != "$CURRENT_RULES_CONTENT" ]; then
    echo "Updating rules..."
    echo "$EXPECTED_RULES_CONTENT" > "$RULES_FILE"
    echo "udev rules were updated."

    # Reload udev rules and trigger
    udevadm control --reload-rules
    udevadm trigger
    echo "udev rules reloaded."
else
    echo "No changes to udev rules required."
fi

echo 'success'
